sets
s scenario /1*2/
t planning periods /1*5/
i supplier /1*4/
a manufacturring /1*3/
l warehouse /1*2/
m Wholesalers /1*2/
c products /1*2/
f transportation mode /1*2/
p Components of a product /1*3/
p23(p) subset of p /2*3/
r Risk region /1*2/;





parameters
PR(s),Ir,FC(i,r,t),FCp(i,r,t),TC(i,a,p,f,t),CAP(i,t),EX1(i,t),EX2(a,t),EX3(l,t),PC(i,a,p,c,t),
FC2(a,r,t),FCp2(a,r,t),TC2(a,c,f,t),CAP2(a,c,t),MC(a,c,t), FC3(l,t),FCp3(l,t),
TC3(l,m,c,f,t), CAP3(l,t),HC(l,c,t),TAX1(i,t),TAX2(a,t),TAX3(l,t),npplus3(l,s),npminus3(l,s),
npplus1(i,s),npminus1(i,s),npplus2(a,s),npminus2(a,s) ;
FC(i,r,t)=uniformint(10,15);
FCp(i,r,t)=uniformint(1.5,2.25);
TC(i,a,p,f,t)=uniformint(500,600);
CAP(i,t)=uniformint(3.2,4.8);
EX1(i,t)=uniformint(1,1);
EX2(a,t)=21768;
EX3(l,t)=50872;
PC(i,a,p,c,t)=uniformint(1200,2100);
FC2(a,r,t)=uniformint(50,75);
FCp2(a,r,t)=uniformint(5,7.5);
TC2(a,c,f,t)=uniformint(300,500);
CAP2(a,c,t)=uniformint(0.8,1.2);
MC(a,c,t)=uniformint(0.8,1.2);
FC3(l,t)=uniformint(2.6,3.8);
FCp3(l,t)=uniformint(0.1,1.3);
TC3(l,m,c,f,t)=uniformint(1.4,1.6);
CAP3(l,t)=uniformint(1.6,2.2);
HC(l,c,t)=uniformint(2.3,3.5);TAX1(i,t)=uniformint(0.25,0.25); TAX2(a,t)=uniformint(0.15,0.15); TAX3(l,t)=uniformint(0.1,0.1);
PR(s)=uniform(0,1);
Ir=.6;
parameter
ww /-.1/;

variable zz1,zz2,zz3,zzf;
positive variables
x(i,a,c,p,t,s),
ix(i,a,c,p,t,s),
xp(i,c,p,f,t,s),
xpr(i,a,c,p,t,s),
pcpr(i,a,p,c,t),
fx(i,a,c,t,s),
fz(i,t,s),
fxpr(i,a,c,t,s),
sx(i,a,c,p,t,s),
sz(i,t,s),
sxpr(i,a,c,p,t,s)  ;
binary variable  es(i,r,t), ms(i,p,r,t), msp(i,p,r,t), rs(i,r,t), em(a,r,t), ew(l,r);

equations
obj1
*obj2
*objf

co22
co231
co232
*co24
co251
co252
co26
co271
co272
;

obj1.. zz1=e= sum((s,t),( PR(s)/power((1+Ir),(ord(t)-1)) )*
              (sum(i,EX1(i,t)*((1-TAX1(i,t))*npplus1(i,s)-npminus1(i,s) ) )+
               sum(a,EX2(a,t)*((1-TAX2(a,t))*npplus2(a,s)-npminus2(a,s) ) )+
               sum(l,EX3(l,t)*((1-TAX3(l,t))*npplus3(l,s)-npminus3(l,s))  )  )  );
$ontext
obj2 .. zz2=e=sum(i,e(i)*z(i))+sum(l,f(l)*w(l))+sum((i,k,j),(a(j)+b(j)*t1(i,k))*x(i,k,j))
         +sum((k,l,j),c(j)*t2(k,l)*y(k,l,j))+sum((l,i,j),(-g(j)+d(j)*t3(l,i))*s(l,i,j))
         +sum((l,j),h(j)*o(j)+t4(l)*t(l,j));

objf .. zzf=e=ww*(zz1.l-(sum(i,e(i)*z(i))+sum(l,f(l)*w(l))+sum((i,k,j),(a(j)+b(j)*t1(i,k))*x(i,k,j))+sum((k,l,j),c(j)*t2(k,l)*y(k,l,j))
         +sum((l,i,j),(-g(j)+d(j)*t3(l,i))*s(l,i,j))+sum((l,j),(h(j)+o(j)*t4(l))*t(l,j)))/zz1.l)

        -(1-ww)*(zz2.l-(sum((i,j),m(i,j)*(sum(k,x(i,k,j))+sum(l,s(l,i,j))))+sum((l,j),n(l,j)*(sum(k,y(k,l,j))+sum(i,s(l,i,j)+t(l,j)))))/zz2.l);
$offtext

co22(i,a,c,t,s,p)    .. pcpr(i,a,p,c,t)*fx(i,a,'1',t,s)+fz(i,t,s)+fxpr(i,a,'1',t,s) =l= 0;
co231(i,a,c,t,s)     .. x(i,a,c,'1',t,s)+fx(i,a,'1',t,s) =g= 0;
co232(i,a,c,t,s)     .. x(i,a,c,'1',t,s)-fx(i,a,'1',t,s) =l= 0;
*co24                .. ;
co251(i,a,c,t,s,p23) .. x(i,a,c,p23,t,s)+ix(i,a,c,p23,t,s) =g= 0;
co252(i,a,c,t,s,p23) .. x(i,a,c,p23,t,s)-ix(i,a,c,p23,t,s) =l= 0;
co26(i,a,c,s,t,p)$(ord(t) >= 2) .. pcpr(i,a,'1',c,t)*sx(i,a,c,p,t,s)+sz(i,t,s)+sxpr(i,a,c,'1',t,s) =l= 0;
co271(i,a,c,s,t)$(ord(t) >= 2) .. xpr(i,a,c,'1',t,s)+sx(i,a,c,'1',t,s) =g= 0 ;
co272(i,a,c,s,t)$(ord(t) >= 2) .. xpr(i,a,c,'1',t,s)-sx(i,a,c,'1',t,s) =l= 0 ;



model ss1 /obj1,co22,co231,co232,co251,co252,co26,co271,co272/;
option optca=0,optcr=0;
option LP=CPLEX ;
solve ss1 using LP minimizing zz1;

$ontext
model ss2 /obj2,co1,co2,co3,co4,co5,co6,co7/
option optca=0,optcr=0,mip=cplex,reslim=3600;

model ssf /objf,co1,co2,co3,co4,co5,co6,co7/
option optca=0,optcr=0,mip=cplex,reslim=3600;


loop(iter,
ww=ww+.1;

solve ss1 using mip min zz1;
solve ss2 using mip max zz2;
solve ssf using mip min zzf;


result(iter,'x1')=sum(i,e(i)*z.l(i))+sum(l,f(l)*w.l(l))+sum((i,k,j),(a(j)+b(j)*t1(i,k))*x.l(i,k,j))
         +sum((k,l,j),c(j)*t2(k,l)*y.l(k,l,j))+sum((l,i,j),(-g(j)+d(j)*t3(l,i))*s.l(l,i,j))
         +sum((l,j),h(j)*o(j)+t4(l)*t.l(l,j));

result(iter,'x2')=sum((i,j),m(i,j)*(sum(k,xl(i,k,j))+sum(l,s.l(l,i,j))))+sum((l,j),n(l,j)*(sum(k,y.l(k,l,j))+sum(i,s.l(l,i,j)+t.l(l,j))));

result(iter,'w1')=ww;
result(iter,'w2')=1-ww;

);

display result;

execute_unload 'weighted_Lpmetric.gdx';
$offtext
